<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task48.10</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
    
    <!-- Font Awesome -->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
    <!-- Data Table-->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

</head>
<body>
    <div class="container">
        <div class = "text-center mt-3">
            <h2>F200 - LỊCH SỬ HỌC TẬP</h2>
        </div>
        <div class = "container jumbotron">
            <div class="row">
              <label class = "col-sm-2 col-form-label">Sinh viên</label>
              <div class = "col-sm-3">
                <select id="select-student-filter" class = "form-control">
                  <option value="all">(All)</option>
                  
                </select>
              </div>
              <label class = "col-sm-2 col-form-label">Môn học</label>
              <div class = "col-sm-3">
                <select id="select-subject-filter" class = "form-control">
                  <option value="all">(All)</option>
                  
                </select>
              </div>
              <button class="btn btn-info col-sm-2" id="btn-filter-orders">Lọc dữ liệu</button>
            </div>
          </div>
        <div class = "form-group">
            <button class = "btn btn-success" id="btn-add-user"><i class="fa fa-plus"></i>&nbsp; Thêm</button>
        </div>
        
        <table id="grade-table" class="table table-bordered table-striped table-hover">
          <thead>
            <tr>
              <th>STT</th>
              <th>Sinh viên</th>
              <th>Môn học</th>
              <th>Điểm</th>
              <th>Ngày thi</th>
              <th>Action</th>
            </tr>
          </thead>
          <tbody>
            
          </tbody>
        </table>
    </div>
    <!-- Create grade modal-->
    <div id="create-grade-modal" class="modal fade" tabindex="-1">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Tạo mới dữ liệu điểm</h5>
                    <button type="button" class="close" data-dismiss="modal">&times;</button>
                </div>
                <!-- Modal body - chứa form dữ liệu -->
                <div class="modal-body"> 
                    <form> <!-- form thiết kế như form bình thường, theo grid model -->
                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">Mã sinh viên</label>
                        <div class="col-sm-8">
                        <select class="form-control" id="select-create-student-id">
                            <option value=0>(Chọn sinh viên)</option>
                            
                        </select>
                        </div>
                    </div>
                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">Mã môn học</label>
                        <div class="col-sm-8">
                        <select class="form-control" id="select-create-subject-id">
                            <option value=0>(Chọn môn học)</option>
                            
                        </select>
                        </div>
                    </div>

                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">Điểm</label>
                        <div class="col-sm-8">
                        <input class="form-control" id="input-create-grade">
                        </div>
                    </div>

                    <div class="row form-group">
                        <label class="col-sm-4 col-form-label">Ngày thi</label>
                        <div class="col-sm-8">
                        <input class="form-control" id="input-create-exam-date">
                        </div>
                    </div>
                    </form>
                </div>
                <div class="modal-footer">
                    <button type="button" id="btn-create-grade" class="btn btn-primary">Tạo mới</button>
                    <button type="button" id="btn-create-cancel" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                </div>
            </div>
        </div>
    </div>
    
    <!-- Edit grade modal-->
    <div id="edit-grade-modal" class="modal fade" tabindex="-1">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Chi tiết điểm</h5>
                    <button type="button" class="close" data-dismiss="modal">&times;</button>
                </div>
                <!-- Modal body - chứa form dữ liệu -->
                <div class="modal-body"> 
                    <form> <!-- form thiết kế như form bình thường, theo grid model -->
                        <div class="row form-group">
                            <label class="col-sm-4 col-form-label">Mã sinh viên</label>
                            <div class="col-sm-8">
                                <input class="form-control" id="input-edit-student-id" readonly>
                            </div>
                        </div>
                        <div class="row form-group">
                            <label class="col-sm-4 col-form-label">Mã môn học</label>
                            <div class="col-sm-8">
                                <input class="form-control" id="input-edit-subject-id" readonly>
                            </div>
                        </div>
    
                        <div class="row form-group">
                            <label class="col-sm-4 col-form-label">Điểm</label>
                            <div class="col-sm-8">
                            <input class="form-control" id="input-edit-grade">
                            </div>
                        </div>
    
                        <div class="row form-group">
                            <label class="col-sm-4 col-form-label">Ngày thi</label>
                            <div class="col-sm-8">
                            <input class="form-control" id="input-edit-exam-date">
                            </div>
                        </div>
                    </form>
                </div>
                <div class="modal-footer">
                    <button type="button" id="btn-update-grade" class="btn btn-success">Cập nhật điểm</button>
                    <button type="button" id="btn-update-cancel" class="btn btn-success" data-dismiss="modal">Hủy bỏ</button>
                </div>
            </div>
        </div>
    </div>

    <!-- Delete confirm modal -->
    <div>
        <div class="modal fade" tabindex="-1" id="delete-grade-modal">
        <div class="modal-dialog">
            <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="h5-modal-title">Confirm xóa dữ liệu điểm</h5>
                <button class="close" data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body">
                <label>Bạn có chắc chắn muốn xóa dữ liệu điểm này không?</label>
            </div>
            <div class="modal-footer">
                <button class="btn btn-danger" id="btn-confirm-delete-grade">Xác nhận</button>
                <button class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
            </div>
            </div>
        </div>
        </div>
    </div>
</body>
<script>
    "use strict";
/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "https://62454a477701ec8f724fb923.mockapi.io/api/v1/";
    const gCONTENT_TYPE = "application/json";

    // Biến toàn cục để lưu trữ id grade đang đc update or delete. Mặc định = 0;
    var gGradeId = 0;
    var gGradeObj = {};
    var gStudentList;
    var gSubjectList;
    var gGradeList;

    // Biến mảng hằng số chứa danh sách tên các thuộc tính
    var gNameCol = ["stt", "studentId", "subjectId", "grade", "examDate", "action"];
    // Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
    const gSTT_COL = 0;
    const gSTUDENT_COL = 1;
    const gSUBJECT_COL = 2;
    const gGRADE_COL = 3;
    const gEXAM_DATE_COL = 4;
    const gACTION_COL = 5;
    var gStt = 0;
    var gGradeTable =  $("#grade-table").DataTable({
        columns: [
          {data: gNameCol[gSTT_COL]},
          {data: gNameCol[gSTUDENT_COL]},
          {data: gNameCol[gSUBJECT_COL]},
          {data: gNameCol[gGRADE_COL]},
          {data: gNameCol[gEXAM_DATE_COL]},
          {data: gNameCol[gACTION_COL]}
            ],
        columnDefs: [ //định nghĩa các cột hiển thị
            { 
            targets: gSTT_COL,
            render: renderStt
            },
            { 
            targets: gSTUDENT_COL,
            render: renderStudentIdToStudentName
            },
            { 
            targets: gSUBJECT_COL,
            render: renderSubjectIdToSubjectName
            },    
            { 
            targets: gACTION_COL,
            className: "text-center", 
            defaultContent: `
            <img class="edit-grade" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
            <img class="delete-grade" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
            `
            },
        ]
      });
/*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
$(document).ready(function(){
    onPageLoading();
});
//gán sự kiện cho nút filter
$("#btn-filter-orders").click(function(){
      onBtnFilterDataClick();
    })
//2-C: gán sự kiện thêm mới
$("#btn-add-user").on("click",function(){
    onBtnAddNewGradeClick(this);
});
//gán sự kiện cho các nút trên create user modal
$("#btn-create-grade").on("click",function(){
    onBtnCreateGradeClick(this);
});

//3-U: gán sự kiện sửa
$("#grade-table").on("click",".edit-grade",function(){
    onBtnEditGradeClick(this);
});
//gán sự kiện cho các nút trên update grade modal
$("#btn-update-grade").on("click",function(){
    onBtnUpdateGradeClick(this);
});

//4-D: gán sự kiện nút xóa 
$("#grade-table").on("click",".delete-grade",function(){
    onBtnDeleteGradeClick(this);
});
//gán sự kiện cho nút xác nhận xóa user modal
$("#btn-confirm-delete-grade").on("click",function(){
    onBtnConfirmDeleteGradeClick(this);
});

/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
function onPageLoading(){
    //1-R: Read /Load grade to data table
    getAllStudents();
    getAllSubjects();
    getAllGrades();
}
//hàm xử lý nút sự kiện filter click
function onBtnFilterDataClick(){
      var vFilterObj = {
        student:"",
        subject: ""
      };
      //b1: thu thập dữ liệu
      thuThapDuLieuFilter(vFilterObj);
      //b2: validate(không có)
      //b3: filter order
      var vFilterResult = filterOrders(vFilterObj);

      //b4: hiển thị dữ liệu sau khi lọc
      loadDataToGradeTable(vFilterResult);
    }
//hàm xử lý sự kiện ấn icon edit grade
function onBtnEditGradeClick(paramBtnEdit){
    //lưu thông tin grade id vào biến toàn cục
    gGradeId = getGradeIdFromButton(paramBtnEdit);
    console.log("Id của dữ liệu điểm tương ứng: " + gGradeId);
    //hiển thị modal lên
    $("#edit-grade-modal").modal("show");
    loadGradeDataToGradeEditModal(gGradeObj);
}
//hàm xử lý sự kiện ấn icon delete grade
function onBtnDeleteGradeClick(paramBtnDelete){
    $("#delete-grade-modal").modal("show");
    //lưu thông tin grade id vào biến toàn cục
    gGradeId = getGradeIdFromButton(paramBtnDelete);
    console.log("Id của dữ liệu điểm tương ứng: " + gGradeId);
}
//hàm xử lý sự kiện ấn nút add grade
function onBtnAddNewGradeClick(){
   //hiển thị modal lên
   $("#create-grade-modal").modal("show");
}
//hàm xử lý sự kiện nhấn nút create grade trên modal
function onBtnCreateGradeClick(){
    //khai báo đối tượng grade obj
    var vObjectRequestData = {
        studentId:"",
        subjectId: "",
        grade: "",
        examDate: ""
    }
    //b1: thu thập dữ liệu input trên modal
    getInsertGradeData(vObjectRequestData);
    //b2: validate
    var vIsValid = validateGradeData(vObjectRequestData);
    //b3: gọi API thêm grade
    if(vIsValid){
        ajaxCreateGrade(vObjectRequestData);
    };
}
//hàm xử lý sự kiện nhấn nút update user trên modal
function onBtnUpdateGradeClick(){
    //khai báo đối tượng grade obj
    var vObjectRequestData = {
        studentId:"",
        subjectId: "",
        grade: "",
        examDate: ""
    }
    //b1: thu thập dữ liệu input trên modal
    getEditedGradeData(vObjectRequestData);
    //b2: validate
    var vIsValid = validateGradeData(vObjectRequestData);
    //b3: gọi API thêm user
    if(vIsValid){
        ajaxUpdateGrade(vObjectRequestData);
    };
}

//hàm xử lý sự kiện xác nhận xóa user
function onBtnConfirmDeleteGradeClick(){
    "use strict";
    //gọi API xóa user
    ajaxDeleteGrade(gGradeId);
}
/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm render số thứ tư
    function renderStt(){
        gStt++;
        return gStt;
    }
    //hàm render Student Name theo student id
    function renderStudentIdToStudentName(paramStudentId){
      "use strict";
      var vStudentName = "NO_NAME";
      var vFound = false;
      var vViTriHienTai = 0;
      while (!vFound && vViTriHienTai < gStudentList.length){
        if (gStudentList[vViTriHienTai].id.toString() === paramStudentId.toString()){
          vStudentName = gStudentList[vViTriHienTai].lastname + " " + gStudentList[vViTriHienTai].firstname;
          vFound = true;
        }
        vViTriHienTai ++;
        }
      return vStudentName;
    }
    //hàm render Subject Name theo Subject id
    function renderSubjectIdToSubjectName(paramSubjectId){
      "use strict";
      var vSubjectName = "NO_NAME";
      var vFound = false;
      var vViTriHienTai = 0;
      while (!vFound && vViTriHienTai < gSubjectList.length){
        if (gSubjectList[vViTriHienTai].id.toString() === paramSubjectId.toString()){
          vSubjectName = gSubjectList[vViTriHienTai].subjectName;
          vFound = true;
        }
        vViTriHienTai ++;
        }
      return vSubjectName;
    }
    //load users to data table
    function loadDataToGradeTable(paramGrades){
        gGradeTable.clear();
        gGradeTable.rows.add(paramGrades);
        gGradeTable.draw();
    }
     //đọc thông tin dùng để lọc
     function thuThapDuLieuFilter(paramFilterObj){
      paramFilterObj.student = $("#select-student-filter").val();
      paramFilterObj.subject = $("#select-subject-filter").val();
    }
    //hàm lọc theo Filter Object
    function filterOrders(paramFilterObj){
      var vGrades = [];
      vGrades = gGradeList.filter(function(paramGrade){
        return ((paramGrade.studentId == paramFilterObj.student || paramFilterObj.student == "all") 
        && (paramGrade.subjectId == paramFilterObj.subject|| paramFilterObj.subject == "all"));
      });
      return vGrades;
    }
    //gọi API load all grades
    function getAllGrades() {
        $.ajax({
            url: gBASE_URL + "/grades",
            type: "GET",
            success: function(paramGrades){
                console.log(paramGrades);
                gGradeList = paramGrades;
                loadDataToGradeTable(paramGrades);
            },
            error: function(paramErr){
                console.log(paramErr.status);
            }
        });
        return gGradeList;
    }
    //gọi API lấy danh sách sinh viên
    function getAllStudents(){
        $.ajax({
            url: gBASE_URL + "/students",
            type: "GET",
            async: false,
            success: function(paramStudents){
                console.log(paramStudents);
                gStudentList = paramStudents;
                handleStudentList(paramStudents);
            },
            error: function(paramErr){
                console.log(paramErr.status);
            }
        });
        return gStudentList;
    }
    //gọi API lấy danh sách môn học
    function getAllSubjects(){
        $.ajax({
            url: gBASE_URL + "/subjects",
            type: "GET",
            async: false,
            success: function(paramSubjects){
                console.log(paramSubjects);
                gSubjectList = paramSubjects;
                handleSubjectList(paramSubjects);
            },
            error: function(paramErr){
                console.log(paramErr.status);
            }
        });
        return gSubjectList;
    }
    //hàm load option cho student select element
    function handleStudentList(paramStudents){
      "use strict";
      var vArrayStudentList = paramStudents;
      //load data to student select filter
      var vSelectStudent = document.getElementById("select-student-filter");
      for (var bI = 0; bI < vArrayStudentList.length; bI++){
        var vStudentOption = document.createElement("option");
        vStudentOption.value = vArrayStudentList[bI].id;
        vStudentOption.text =  vArrayStudentList[bI].lastname + " " + vArrayStudentList[bI].firstname;
        //thêm obtion cho filter
        vSelectStudent.appendChild(vStudentOption);
      }
      //load data to student select create
      var vCreateStudent = document.getElementById("select-create-student-id");
      for (var bIndex = 0; bIndex < vArrayStudentList.length; bIndex++){
        var vStudentOption = document.createElement("option");
        vStudentOption.value = vArrayStudentList[bIndex].id;
        vStudentOption.text =  vArrayStudentList[bIndex].lastname + " " + vArrayStudentList[bIndex].firstname;
        //thêm option trên modal
        vCreateStudent.appendChild(vStudentOption);
      }
    }
    //hàm load option cho subject select element
    function handleSubjectList(paramSubjects){
      "use strict";
      var vArraySubjectList = paramSubjects;
      //load data to subject select filter
      var vSelectSubject = document.getElementById("select-subject-filter");
      for (var bI = 0; bI < vArraySubjectList.length; bI++){
        var vSubjectOption = document.createElement("option");
        vSubjectOption.value = vArraySubjectList[bI].id;
        vSubjectOption.text =  vArraySubjectList[bI].subjectName;
        //thêm obtion cho filter
        vSelectSubject.appendChild(vSubjectOption);
      }
      //load data to subject select Create
      var vCreateSubject = document.getElementById("select-create-subject-id");
      for (var bIndex = 0; bIndex < vArraySubjectList.length; bIndex++){
        var vSubjectOption = document.createElement("option");
        vSubjectOption.value = vArraySubjectList[bIndex].id;
        vSubjectOption.text =  vArraySubjectList[bIndex].subjectName;
        //thêm option trên modal
        vCreateSubject.appendChild(vSubjectOption);
      }
    }
    //hàm xác định grade id từ button
    function getGradeIdFromButton(paramButton){
        var vTableRow = $(paramButton).parents("tr");
        var vGradeRowData = gGradeTable.row(vTableRow).data();
        gGradeObj = vGradeRowData;
        return vGradeRowData.id;
    }
    //hàm đọc thông tin user data được thêm
    function getInsertGradeData(paramGradeObj){
        paramGradeObj.studentId = $("#select-create-student-id").val();
        paramGradeObj.subjectId = $("#select-create-subject-id").val();
        paramGradeObj.grade = $("#input-create-grade").val();
        paramGradeObj.examDate = $("#input-create-exam-date").val();
    }
    //hàm load thông tin grade ban đầu lên modal
    function loadGradeDataToGradeEditModal(paramGradeObj){
        $("#input-edit-student-id").val(paramGradeObj.studentId);
        $("#input-edit-subject-id").val(paramGradeObj.subjectId);
        $("#input-edit-grade").val(paramGradeObj.grade);
        $("#input-edit-exam-date").val(paramGradeObj.examDate);
    }
    //hàm đọc thông tin grade data được edited
    function getEditedGradeData(paramGradeObj){
        paramGradeObj.studentId = $("#input-edit-student-id").val();
        paramGradeObj.subjectId = $("#input-edit-subject-id").val().trim();
        paramGradeObj.grade = $("#input-edit-grade").val();
        paramGradeObj.examDate = $("#input-edit-exam-date").val();
    }
    //hàm validate grade data
    function validateGradeData(paramGradeObj){
        if (paramGradeObj.studentId == 0 ||
        paramGradeObj.subjectId == 0 ||
        paramGradeObj.grade == "" ||
        paramGradeObj.examDate == ""){
            alert("Cần nhập đầy đủ thông tin");
            return false;
        }
        return true;
    }
    //API thêm grade
    function ajaxCreateGrade(paramGradeRequest){
        "use strict";
        $.ajax({
            url: gBASE_URL + "/grades",
            type: "POST",
            contentType: gCONTENT_TYPE,
            data: JSON.stringify(paramGradeRequest),
            success: function(paramRes){
                console.log(paramRes);
                //b4: xử lý hiển thị
                handleCreateGradeSuccess();
            },
            error: function(paramErr){
                console.log(paramErr.status);
            }
        });
    }
    //hàm xử lý hiển thị khi thêm grade mới thành công
    function handleCreateGradeSuccess(){
        alert("Thêm dữ liệu điểm thành công!");
        //reload data on table
        getAllGrades();
        resetGradeForm();
        $("#create-grade-modal").modal("hide");
    }
    //hàm xóa thông tin trên form create grade modal
    function resetGradeForm(){
        $("#select-create-student-id").val("");
        $("#select-create-subject-id").val("");
        $("#input-create-grade").val("");
        $("#select-create-exam-date").val("");
            
    };
    //API update grade
    function ajaxUpdateGrade(paramGradeRequest){
        "use strict";
        $.ajax({
            url:  gBASE_URL + "/grades/" + gGradeId,
            type: "PUT",
            contentType: gCONTENT_TYPE,
            data: JSON.stringify(paramGradeRequest),
            success: function(paramRes){
                console.log(paramRes);
                //b4: xử lý hiển thị
                handleUpdateGradeSuccess();
            },
            error: function(paramErr){
                console.log(paramErr.status);
            }
        });
    }
    //hàm xử lý hiển thị khi user cập nhật thành công
    function handleUpdateGradeSuccess(){
        alert("Cập nhật điểm thành công!");
        //reload data on table
        getAllGrades();
        $("#edit-grade-modal").modal("hide");
    }
    //API delete user
    function ajaxDeleteGrade(paramUserId){
        "use strict";
        $.ajax({
            url:  gBASE_URL + "/grades/" + gGradeId,
            type: "DELETE",
            success: function(paramRes){
                console.log(paramRes);
                //b4: xử lý hiển thị
                handleDeleteGradeSuccess();
            },
            error: function(paramErr){
                console.log(paramErr.status);
            }
        });
    }
    //hàm xử lý hiển thị khi xóa dữ liêu điểm thành công
    function handleDeleteGradeSuccess(){
        alert("Xóa dữ liệu điểm thành công!");
        //reload data on table
        getAllGrades();
        $("#delete-grade-modal").modal("hide");
    }
</script>
</html>